#ifndef __IDT_H__
#define __IDT_H__


interface CDropTarget : public IDropTarget
{
	private:
		ULONG m_cRefCount;
		bool deleteself;
		CDropTarget** pthis;

		DWORD LastKeyState;

	public:
		//Members
		CDropTarget( bool delself = false, CDropTarget** p = NULL );
		~CDropTarget();

		//IUnknown members
		STDMETHODIMP QueryInterface( REFIID iid, void** ppvObject );
		STDMETHODIMP_(ULONG) AddRef( void );
		STDMETHODIMP_(ULONG) Release( void );

		//IDropTarget methods
		STDMETHODIMP DragEnter( IDataObject* pDataObject, DWORD grfKeyState, POINTL pt, DWORD* pdwEffect );
		STDMETHODIMP DragOver( DWORD grfKeyState, POINTL pt, DWORD* pdwEffect );
		STDMETHODIMP DragLeave( void );
		STDMETHODIMP Drop( IDataObject* pDataObject, DWORD grfKeyState, POINTL pt, DWORD * pdwEffect );
};


struct DROPPARAMS{
	bool needeffect;
	bool effect;
	FORMATETC* formats;
	UINT numformats;
	UINT formatnumber;
};


#endif //__IDT_H__